package de.cliffbreak.varo.managers;

import java.time.Instant;
import java.time.LocalDateTime;

import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.World.Environment;
import org.bukkit.WorldBorder;

import de.cliffbreak.varo.Varo;

public class BorderManager {

    private final Varo plugin;

    public BorderManager(final Varo plugin) {
        this.plugin = plugin;
        init();
    }

    private void init() {
        final int size = this.plugin.getConfig().getInt("Varo.Border.Size");
        final int x = this.plugin.getConfig().getInt("Varo.Border.X");
        final int z = this.plugin.getConfig().getInt("Varo.Border.Z");
        for (World world : Bukkit.getWorlds()) {
            Environment env = world.getEnvironment();
            if (env.equals(Environment.THE_END))
                continue;
            final WorldBorder border = world.getWorldBorder();
            border.reset();
            border.setCenter(x, z);
            border.setSize(env.equals(Environment.NORMAL) ? size : (size / 8));
            border.setWarningDistance(25);
            border.setWarningTime(0);
            border.setDamageAmount(1);
            border.setDamageBuffer(0);
        }
    }

    public LocalDateTime shrinkBorder() {
        this.plugin.getConfig().set("Varo.Border.LastUpdate", Instant.now().toEpochMilli());
        int size = this.plugin.getConfig().getInt("Varo.Border.NextSize");
        size = size - 150; // 75*2 for both directions
        this.plugin.getConfig().set("Varo.Border.Size", size);
        this.plugin.saveConfig();
        return LocalDateTime.now();
    }

    public int addPlayerDeath() {
        int size = this.plugin.getConfig().getInt("Varo.Border.NextSize");
        size = size - 50; // 25*2 for both directions
        this.plugin.getConfig().set("Varo.Border.NextSize", size);
        this.plugin.saveConfig();
        return size;
    }
}